<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInterfaceVehicleResult_V9 ArrayType
 * @subpackage Arrays
 */
class ArrayOfInterfaceVehicleResult_V9 extends AbstractStructArrayBase
{
    /**
     * The InterfaceVehicleResult_V9
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InterfaceVehicleResult_V9[]
     */
    public $InterfaceVehicleResult_V9;
    /**
     * Constructor method for ArrayOfInterfaceVehicleResult_V9
     * @uses ArrayOfInterfaceVehicleResult_V9::setInterfaceVehicleResult_V9()
     * @param \StructType\InterfaceVehicleResult_V9[] $interfaceVehicleResult_V9
     */
    public function __construct(array $interfaceVehicleResult_V9 = array())
    {
        $this
            ->setInterfaceVehicleResult_V9($interfaceVehicleResult_V9);
    }
    /**
     * Get InterfaceVehicleResult_V9 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InterfaceVehicleResult_V9[]|null
     */
    public function getInterfaceVehicleResult_V9()
    {
        return isset($this->InterfaceVehicleResult_V9) ? $this->InterfaceVehicleResult_V9 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInterfaceVehicleResult_V9 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInterfaceVehicleResult_V9 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInterfaceVehicleResult_V9ForArrayConstraintsFromSetInterfaceVehicleResult_V9(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInterfaceVehicleResult_V9InterfaceVehicleResult_V9Item) {
            // validation for constraint: itemType
            if (!$arrayOfInterfaceVehicleResult_V9InterfaceVehicleResult_V9Item instanceof \StructType\InterfaceVehicleResult_V9) {
                $invalidValues[] = is_object($arrayOfInterfaceVehicleResult_V9InterfaceVehicleResult_V9Item) ? get_class($arrayOfInterfaceVehicleResult_V9InterfaceVehicleResult_V9Item) : sprintf('%s(%s)', gettype($arrayOfInterfaceVehicleResult_V9InterfaceVehicleResult_V9Item), var_export($arrayOfInterfaceVehicleResult_V9InterfaceVehicleResult_V9Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InterfaceVehicleResult_V9 property can only contain items of type \StructType\InterfaceVehicleResult_V9, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InterfaceVehicleResult_V9 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InterfaceVehicleResult_V9[] $interfaceVehicleResult_V9
     * @return \ArrayType\ArrayOfInterfaceVehicleResult_V9
     */
    public function setInterfaceVehicleResult_V9(array $interfaceVehicleResult_V9 = array())
    {
        // validation for constraint: array
        if ('' !== ($interfaceVehicleResult_V9ArrayErrorMessage = self::validateInterfaceVehicleResult_V9ForArrayConstraintsFromSetInterfaceVehicleResult_V9($interfaceVehicleResult_V9))) {
            throw new \InvalidArgumentException($interfaceVehicleResult_V9ArrayErrorMessage, __LINE__);
        }
        if (is_null($interfaceVehicleResult_V9) || (is_array($interfaceVehicleResult_V9) && empty($interfaceVehicleResult_V9))) {
            unset($this->InterfaceVehicleResult_V9);
        } else {
            $this->InterfaceVehicleResult_V9 = $interfaceVehicleResult_V9;
        }
        return $this;
    }
    /**
     * Add item to InterfaceVehicleResult_V9 value
     * @throws \InvalidArgumentException
     * @param \StructType\InterfaceVehicleResult_V9 $item
     * @return \ArrayType\ArrayOfInterfaceVehicleResult_V9
     */
    public function addToInterfaceVehicleResult_V9(\StructType\InterfaceVehicleResult_V9 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterfaceVehicleResult_V9) {
            throw new \InvalidArgumentException(sprintf('The InterfaceVehicleResult_V9 property can only contain items of type \StructType\InterfaceVehicleResult_V9, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InterfaceVehicleResult_V9[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InterfaceVehicleResult_V9|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InterfaceVehicleResult_V9|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InterfaceVehicleResult_V9|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InterfaceVehicleResult_V9|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InterfaceVehicleResult_V9|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InterfaceVehicleResult_V9
     */
    public function getAttributeName()
    {
        return 'InterfaceVehicleResult_V9';
    }
}
